//This is a trial file which requires inputs in terminal

#include <iostream>
#include <string>
#include <cstdlib>
#include <ctime>
#include <cstdio>
using namespace std;
#include "rect.h"
#include "label.h"
#include <cmath>
#include "ezwin.h"
#include <cassert>
Position P;
SimpleWindow MyWindow("BLOXORZ", 30.0, 20.0,Position(0.0, 0.0));
//position of the block
int pc[5]={0,1,2,3};
int xl,xr,yt,yb;
int level;
int n,a[15][15];

//intialized
double pi=3.1415929;
//Defining functions
void passcode();
void fate(); 
int g;
//function to input an array
void input(int arrayin[150],int arrayout[10][15])
{
int i,j,count=0;
for(j=0;j<15;j++)
    {
    for(i=0;i<10;i++){arrayout[i][j]=arrayin[count];count++;}
    }
}
 
//function for measuring distance between two points
float distance(float a1, float b1, float a2, float b2)
{
                                                	float c;
                                                   	c=sqrt((a1-a2)*(a1-a2)+(b1-b2)*(b1-b2));
                                                          	return c;
}
//function to make a black sided quadrilateral given four co-ordinates
//similar codes written for different colours
//function to describe quad with bold sides. Used for colouring                                                                                         	}
void boldquad1(float x[4] , float y[4])
{
MyWindow.RenderLine(Position(x[0],y[0]), Position(x[1],y[1]), Black, 0.1);
MyWindow.RenderLine(Position(x[2],y[2]), Position(x[3],y[3]), Black, 0.1);
MyWindow.RenderLine(Position(x[3],y[3]), Position(x[0],y[0]), Black, 0.1);
MyWindow.RenderLine(Position(x[1],y[1]), Position(x[2],y[2]), Black, 0.1);
}
 
 
void boldquad4(float x[4] , float y[4])
{
MyWindow.RenderLine(Position(x[0],y[0]), Position(x[1],y[1]), Yellow, 0.1);
MyWindow.RenderLine(Position(x[2],y[2]), Position(x[3],y[3]), Yellow, 0.1);
MyWindow.RenderLine(Position(x[3],y[3]), Position(x[0],y[0]), Yellow, 0.1);
MyWindow.RenderLine(Position(x[1],y[1]), Position(x[2],y[2]), Yellow, 0.1);
}

 
void boldquad3(float x[4] , float y[4])
{
MyWindow.RenderLine(Position(x[0],y[0]), Position(x[1],y[1]), Blue, 0.1);
MyWindow.RenderLine(Position(x[2],y[2]), Position(x[3],y[3]), Blue, 0.1);
MyWindow.RenderLine(Position(x[3],y[3]), Position(x[0],y[0]), Blue, 0.1);
MyWindow.RenderLine(Position(x[1],y[1]), Position(x[2],y[2]), Blue, 0.1);
}
 
void boldquad5(float x[4] , float y[4])
{
MyWindow.RenderLine(Position(x[0],y[0]), Position(x[1],y[1]), White, 0.1);
MyWindow.RenderLine(Position(x[2],y[2]), Position(x[3],y[3]), White, 0.1);
MyWindow.RenderLine(Position(x[3],y[3]), Position(x[0],y[0]), White, 0.1);
MyWindow.RenderLine(Position(x[1],y[1]), Position(x[2],y[2]), White, 0.1);
}
 
//function to colour a polygon with desired color(defined by fixed integer for each one)
 void colorquad(float x[4], float y[4],int k)
{
                                 	switch(k)            	{
                                                                	case 0:{
 
break;}
case 2:{
  float xc,yc,co[4],r[4],si[4];
  int i,j;
  
float m[4]={x[0],x[1],x[2],x[3]},k[4]={y[0],y[1],y[2],y[3]};
//finding point of intersection of diagonal
xc=(1/((y[3]-y[1])/(x[3]-x[1])-(y[0]-y[2])/(x[0]-x[2])))*(y[2]-y[1]-x[2]*(y[0]-y[2])/(x[0]-x[2])+x[1]*(y[3]-y[1])/(x[3]-x[1]));
 yc=y[2]+(y[0]-y[2])*(xc-x[2])/(x[0]-x[2]);
 
 for(i=0;i<4;i++)
 {
 r[i]=distance(xc,yc,x[i],y[i]);
  co[i]=(x[i]-xc)/r[i];
  si[i]=(y[i]-yc)/r[i]; }
 do{
    	for(i=0;i<4;i++)
 {
 r[i]=r[i]-0.01*r[i];
}
  for(i=0;i<4;i++)
 {
  x[i]=xc+r[i]*co[i];
 y[i]=yc+r[i]*si[i];
}
boldquad4(x,y);
 
}
 while(r[0]>0.1);
boldquad1(m,k);
MyWindow.RenderLine(Position(xc,yc), Position(xc,yc), Yellow, 0.1);
 break;} 

case 1:{
 
 
  float xc,yc,co[4],r[4],si[4];
  int i,j;
 
float m[4]={x[0],x[1],x[2],x[3]},k[4]={y[0],y[1],y[2],y[3]};
//finding point of intersection of diagonal
xc=(1/((y[3]-y[1])/(x[3]-x[1])-(y[0]-y[2])/(x[0]-x[2])))*(y[2]-y[1]-x[2]*(y[0]-y[2])/(x[0]-x[2])+x[1]*(y[3]-y[1])/(x[3]-x[1]));
 yc=y[2]+(y[0]-y[2])*(xc-x[2])/(x[0]-x[2]);
 
 for(i=0;i<4;i++)
 {
 r[i]=distance(xc,yc,x[i],y[i]);
  co[i]=(x[i]-xc)/r[i];
  si[i]=(y[i]-yc)/r[i]; }
 do{
    	for(i=0;i<4;i++)
 {
 r[i]=r[i]-0.01*r[i];
}
  for(i=0;i<4;i++)
 {
  x[i]=xc+r[i]*co[i];
 y[i]=yc+r[i]*si[i];
}
 boldquad3(x,y);
 
 }
 while(r[0]>0.1);
boldquad1(m,k);
MyWindow.RenderLine(Position(xc,yc), Position(xc,yc), Blue, 0.1);
 break;}

case 3:{
 
 
  float xc,yc,co[4],r[4],si[4];
  int i,j;
  
float m[4]={x[0],x[1],x[2],x[3]},k[4]={y[0],y[1],y[2],y[3]};
//finding point of intersection of diagonal
xc=(1/((y[3]-y[1])/(x[3]-x[1])-(y[0]-y[2])/(x[0]-x[2])))*(y[2]-y[1]-x[2]*(y[0]-y[2])/(x[0]-x[2])+x[1]*(y[3]-y[1])/(x[3]-x[1]));
 yc=y[2]+(y[0]-y[2])*(xc-x[2])/(x[0]-x[2]);
 
 for(i=0;i<4;i++)
 {
 r[i]=distance(xc,yc,x[i],y[i]);
  co[i]=(x[i]-xc)/r[i];
  si[i]=(y[i]-yc)/r[i]; }
 do{
    	for(i=0;i<4;i++)
 {
 r[i]=r[i]-0.01*r[i];
}
  for(i=0;i<4;i++)
 {
  x[i]=xc+r[i]*co[i];
 y[i]=yc+r[i]*si[i];
}
boldquad5(x,y);
 }
 while(r[0]>0.1);
boldquad1(m,k);
MyWindow.RenderLine(Position(xc,yc), Position(xc,yc), White, 0.1);
}
}
}
 
//program to find new co-ordinates(in 3D) of given co-ordinates in 2D
void rotatex(float *x, float *y, float *z, int t){
	*z=1;
	float k=t*pi/180;
	*z=*z*cos(k) + *y*sin(k);
	*y=*y*cos(k) - *z*sin(k); // Using the rotation formula about x axis
}

void rotatey(float *x, float *y, float *z, int t){
	float k=t*pi/180;
	*x=*x*cos(k) + *z*sin(k);
	*z=*z*cos(k) - *x*sin(k); // Using the rotation formula about y axis
}

void rotatez(float *x, float *y, float *z, int t){
	float k=t*pi/180;
	*y=*y*cos(k) + *x*sin(k);
	*x=*x*cos(k) - *y*sin(k); }// Using the rotation formula about z axis
//function to make a tile of the maze   							 
void maketile(float x[4],float y[4],float z[4], int k)
{
int p=25;
int i;
for(i=0;i<4;i++)
{
   	rotatex(&x[i],&y[i],&z[i],p);
   	rotatey(&x[i],&y[i],&z[i],p);
 	//  cout<<x[i]<<" ";
  	// cout<<y[i]<<" ";
   	 
 }//cout<<endl;
colorquad(x,y,k);
}
 
//function to make a maze from given array
void makemaze(int array[15][15], float xs,float ys)
{
MyWindow.RenderRectangle(Position(0.0,0.0),Position(30.0,30.0),Black);
int i,j;
float x[4],y[4],z[4];
for(i=0; i<4; i++){z[i]=1.0;}
for(j=0;j<15;j++)
{
for(i=0;i<15;i++)
{
x[0]=xs+2*i;
y[0]=ys+2*j;
x[1]=x[0];
y[1]=y[0]+2;
x[2]=x[0]+2;
y[2]=y[0]+2;
x[3]=x[0]+2;
y[3]=y[0];
maketile(x,y,z,array[i][j]);
}
}
   	MyWindow.RenderRectangle(Position(16,12), Position(18,13.9),Yellow, true);
	MyWindow.RenderRectangle(Position(14,14.1), Position(15.9,16),Yellow, true);	
	MyWindow.RenderRectangle(Position(16,14.1), Position(18,16),Yellow, true);
	MyWindow.RenderRectangle(Position(18.1,14.1), Position(20,16),Yellow, true);
	MyWindow.RenderText(Position(16,12), Position(18,13.9),"UP", Red);
	MyWindow.RenderText(Position(14,14.1), Position(15.9,16),"LEFT", Red);	
	MyWindow.RenderText(Position(16,14.1), Position(18,16),"DOWN", Red);
	MyWindow.RenderText(Position(18.1,14.1), Position(20,16),"RIGHT", Red);
   	
}

//passcode function
void passcode(){
float xs=3.0,ys=3.0;
int i,j,strtx=0,strty=1;


xr=strtx;
xl=xr;
yb=strty;
yt=yb;
switch(n){
case 1:{  for(i=0;i<15;i++){
   		 for(j=0;j<15;j++){a[i][j]=(i+j)%3;}   		 
   		 }
level=1;
//cin>>level1;
makemaze(a,xs,ys);
//move the block
//return passcode of next level if complete as 'n'=a[2]
//return passcode of same level as 'n' if block falls down i.e. n=a[1]
//passcode(n);
break;}
 
case 2:{  
level=2;
for(i=0;i<15;i++){
   		 for(j=0;j<15;j++){a[i][j]=(i+j)%3;}   		 
   		 }
makemaze(a,xs,ys);

 
//move the block
//return passcode of next level if complete as 'n'=a[3]
//return passcode of same level as 'n' if block falls down i.e. n=a[2]
//passcode(n);
break;}
case 3:{  
//cin>>level3;
level=3;
for(i=0;i<15;i++){
   		 for(j=0;j<15;j++){a[i][j]=(i+j)%3;}   		 
   		 }
makemaze(a,xs,ys);
//move the block
//return passcode of next level if complete as 'n'=a[4]
//return passcode of same level as 'n' if block falls down i.e. n=a[3]
//passcode(n);
break;}
default:{  
//cin>>level0;
level=0;
for(i=0;i<15;i++){
   		 for(j=0;j<15;j++){a[i][j]=(i*j)%3;}   		 
   		 }
makemaze(a,xs,ys);
//move the block
//return passcode of next level if complete as 'n'=a[1]
//return passcode of same level as 'n' if block falls down i.e. n=a[0]
//passcode(n);
break;
}
}

fate();
}
//Function to introduce delay [COPIED FROM www.cplusplus.com]
void wait ( float milliseconds )
{
	clock_t endwait;
	endwait = clock () + milliseconds * CLOCKS_PER_SEC/1000 ;
	while (clock() < endwait) {}
}

//moving down
void movedown()
{
if(xl==xr&&yt==yb)
 {
  if(yb<8)
  {yb=yb+2; yt=yt+1;}
  else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }

else if(yt!=yb)
 {
  
  if(yb<9)
  {yb++; yt=yb;}
  else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }

else if(xl!=xr)
 {
   if(yb<9)
  {yt++; yb++;}
  else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }
}


//moving up
void moveup()
{
if(xl==xr&&yt==yb)
 {if(yt>1)
  {yb=yb-1; yt=yt-2;}
else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }

else if(yt!=yb)
 {if(yt>0)
  {yt--; yb=yt;}
else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }

else if(xl!=xr)
 {if(yt>0)
  {yb--; yt--;}
else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }
}

//move right
void moveright()
{
if(xl==xr&&yt==yb)
 {
  if(xr<13)
  {xr=xr+2; xl=xl+1;
  }
  else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }

else if(xl!=xr)
 {
  
  if(xr<14)
  {xr++; xl=xr;}
  else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }

else if(yt!=yb)
 {
   if(xr<14)
  {xr++; xl++;}
  else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }
}

//move left
void moveleft()
{
if(xl==xr&&yt==yb)
 {
  if(xl>1)
  {xl=xl-2; xr=xr-1;}
  else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }

else if(xl!=xr)
 {
  
  if(xl>0)
  {xl--; xr=xl;}
  else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
 wait(4000);
  n=pc[level];
  }
 }

else if(yt!=yb)
 {
   if(xl>0)
  {xl--; xr--;}
  else{
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];
  }
 }
}

void correcter();
//detecting users command copied from sanchar and jinit
int blockmove(const Position &P)
{
 if(P.GetXDistance()>16&&P.GetXDistance()<18&&P.GetYDistance()>12&&P.GetYDistance()<13.9) //UP
  {moveup();}
 else if(P.GetXDistance()>14&&P.GetXDistance()<15.9&&P.GetYDistance()>14.1&&P.GetYDistance()<16) //LEFT
  {moveleft();}
 else if(P.GetXDistance()>16&&P.GetXDistance()<18&&P.GetYDistance()>14.1&&P.GetYDistance()<16) //DOWN
  {movedown();}
 else if(P.GetXDistance()>18.1&&P.GetXDistance()<20&&P.GetYDistance()>14.1&&P.GetYDistance()<16) //RIGHT 
  {moveright();}
 else{correcter();}
fate();
return 0;
}
void correcter(){MyWindow.SetMouseClickCallback(blockmove);}

//block's fate
void fate()
{

for(int i=0;i<15;i++){cout<<a[i][0]<<" ";}
if(xl==xr&&yt==yb)
 {
  g=a[xl][yt];cout<<"g"<<g<<endl;cout<<"lodifs"<<xl<<" "<<xr<<" "<<yt<<" "<<yb<<endl;
 }

else if(xl!=xr)
 {
  if(a[xl][yt]>=a[xr][yt]){g=a[xr][yt];}
  else if(a[xr][yt]>a[xl][yt]){g=a[xl][yt];}
 }

else if(yt!=yb)
 {
  if(a[xl][yt]>=a[xr][yb]){g=a[xr][yb];}
  else if(a[xr][yb]>a[xl][yt]){g=a[xl][yt];}
 }
cout<<"g"<<g<<endl;
switch(g)
{
 case 0:
 {

  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];passcode();
  break;
 }
 case 1:
 {
n=pc[level];MyWindow.SetMouseClickCallback(blockmove);
 break;
 }
 case 2:
 {

  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"GAME OVER \n RESTARTING LEVEL", Red);
  wait(4000);
  n=pc[level];passcode();
  break;
 }
 case 3:
 {
  MyWindow.RenderRectangle(Position(10,10), Position(15,15),Yellow, true);
  MyWindow.RenderText(Position(10,10), Position(15,15),"CONGRATULATIONS \n STARTING NEXT LEVEL", Red);
  wait(4000);
  n=pc[level+1];passcode();
  break;
 }
//default:
  //{n=pc[level];}
}

}


int ApiMain(){
	MyWindow.Open();
   	assert(MyWindow.GetStatus() == WindowOpen);
	
	float x[4], y[4], z[4];
    	int i,j;
	MyWindow.RenderText(Position(11.0,11.0),Position(15.0,15.0),"enter passcode or start from level 0",Green);
   	cin>>n;
	passcode();
	return 0;
}





